package com.yuchen.saas.manage.dict.api.cache;

import com.yuchen.saas.manage.dict.api.entity.Dict;
import com.yuchen.saas.manage.dict.api.enums.DictEnum;
import com.yuchen.saas.manage.dict.api.feign.IDictClient;
import org.nest.springwrap.core.cache.utils.CacheUtil;
import org.nest.springwrap.core.tool.api.R;
import org.nest.springwrap.core.tool.utils.SpringUtil;
import org.nest.springwrap.core.tool.utils.StringPool;

import java.util.List;
import java.util.Optional;

import static org.nest.springwrap.core.cache.constant.CacheConstant.DICT_CACHE;


public class DictCache {

    private static final String DICT_ID = "dict:id:";
    private static final String DICT_KEY = "dict:key:";
    private static final String DICT_VALUE = "dict:value:";
    private static final String DICT_LIST = "dict:list:";

    private static final Boolean TENANT_MODE = Boolean.FALSE;

    private static IDictClient dictClient;

    private static IDictClient getDictClient() {
        if (dictClient == null) {
            dictClient = SpringUtil.getBean(IDictClient.class);
        }
        return dictClient;
    }


    public static Dict getById(Long id) {
        return CacheUtil.get(DICT_CACHE, DICT_ID, id, () -> {
            R<Dict> result = getDictClient().getById(id);
            return result.getData();
        }, TENANT_MODE);
    }


    public static String getKey(DictEnum code, String dictValue) {
        return getKey(code.getName(), dictValue);
    }


    public static String getKey(String code, String dictValue) {
        return CacheUtil.get(DICT_CACHE, DICT_KEY + code + StringPool.COLON, dictValue, () -> {
            List<Dict> list = getList(code);
            Optional<String> key = list.stream().filter(
                    dict -> dict.getDictValue().equalsIgnoreCase(dictValue)
            ).map(Dict::getDictKey).findFirst();
            return key.orElse(StringPool.EMPTY);
        }, TENANT_MODE);
    }


    public static String getValue(DictEnum code, Integer dictKey) {
        return getValue(code.getName(), dictKey);
    }


    public static String getValue(String code, Integer dictKey) {
        return CacheUtil.get(DICT_CACHE, DICT_VALUE + code + StringPool.COLON, String.valueOf(dictKey), () -> {
            R<String> result = getDictClient().getValue(code, String.valueOf(dictKey));
            return result.getData();
        }, TENANT_MODE);
    }


    public static String getValue(DictEnum code, String dictKey) {
        return getValue(code.getName(), dictKey);
    }


    public static String getValue(String code, String dictKey) {
        return CacheUtil.get(DICT_CACHE, DICT_VALUE + code + StringPool.COLON, dictKey, () -> {
            R<String> result = getDictClient().getValue(code, dictKey);
            return result.getData();
        }, TENANT_MODE);
    }


    public static List<Dict> getList(String code) {
        return CacheUtil.get(DICT_CACHE, DICT_LIST, code, () -> {
            R<List<Dict>> result = getDictClient().getList(code);
            return result.getData();
        }, TENANT_MODE);
    }

}
